<?php

namespace Lc\ShopBundle\Model;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;

/**
 * @ORM\MappedSuperclass()
 */
abstract class OrderStatus
{

        /**
         * @ORM\Column(type="string", length=255)
         */
        protected $title;

        /**
         * @ORM\Column(type="text", nullable=true)
         */
        protected $description;

        /**
         * @ORM\ManyToMany(targetEntity="Lc\ShopBundle\Context\OrderStatusInterface")
         */
        protected $nextStatusAllowed;

        /**
         * @ORM\Column(type="string", length=255)
         */
        protected $alias;

        public function __toString()
        {
                return $this->title. ' ['.$this->alias.']';
        }

        public function __construct()
        {
                $this->nextStatusAllowed = new ArrayCollection();
        }

        public function getTitle(): ?string
        {
                return $this->title;
        }

        public function setTitle(string $title): self
        {
                $this->title = $title;

                return $this;
        }

        public function getDescription(): ?string
        {
                return $this->description;
        }

        public function setDescription(?string $description): self
        {
                $this->description = $description;

                return $this;
        }

        /**
         * @return Collection|self[]
         */
        public function getNextStatusAllowed(): Collection
        {
                return $this->nextStatusAllowed;
        }

        public function addNextStatusAllowed(self $nextStatusAllowed): self
        {
                if (!$this->nextStatusAllowed->contains($nextStatusAllowed)) {
                        $this->nextStatusAllowed[] = $nextStatusAllowed;
                }

                return $this;
        }

        public function removeNextStatusAllowed(self $nextStatusAllowed): self
        {
                if ($this->nextStatusAllowed->contains($nextStatusAllowed)) {
                        $this->nextStatusAllowed->removeElement($nextStatusAllowed);
                }

                return $this;
        }

        public function getAlias(): ?string
        {
                return $this->alias;
        }

        public function setAlias(string $alias): self
        {
                $this->alias = $alias;

                return $this;
        }


}
